/*
 * test_gulium.c -- Test Gulim's advance width
 *
 * How to compile:
 * i686-w64-mingw32-gcc -o test_gulim.exe ./test_gulim.c -lgdi32
 */

#include <windows.h>
#include <stdio.h>

static void test_advance(HDC hdc, HFONT hfont)
{
    HFONT hfont_old;
    MAT2 mat = {{0,1},{0,0},{0,0},{0,1}};
    GLYPHMETRICS gm;
    char text[128];
    int bufsize;
    char *buffer;

    hfont_old = SelectObject(hdc, hfont);

    GetTextFace(hdc, sizeof(text), text);
    printf("Face: %s\n", text);
    bufsize = GetGlyphOutlineW(hdc, 0xc640, GGO_GRAY4_BITMAP, &gm, 0, NULL, &mat);
    buffer = malloc(bufsize);
    bufsize = GetGlyphOutlineW(hdc, 0xc640, GGO_GRAY4_BITMAP, &gm, bufsize, buffer, &mat);
    if (bufsize != GDI_ERROR)
        printf("gmCellIncX: %hd\n", gm.gmCellIncX);

    printf("\n");
    SelectObject(hdc, hfont_old);
}

int main(int argc, char* argv[])
{
    HDC hdc = GetDC(NULL);
    HFONT hfont_gulim, hfont_gulimche;
    LOGFONT lf;

    memset(&lf, 0, sizeof(lf));
    lf.lfCharSet = HANGUL_CHARSET;
    lf.lfHeight = -19;
    lf.lfWeight = FW_NORMAL;

    strcpy(lf.lfFaceName, "Gulim");
    hfont_gulim = CreateFontIndirect(&lf);
    test_advance(hdc, hfont_gulim);

    strcpy(lf.lfFaceName, "GulimChe");
    hfont_gulimche = CreateFontIndirect(&lf);
    test_advance(hdc, hfont_gulimche);

    DeleteObject(hfont_gulim);
    DeleteObject(hfont_gulimche);

    ReleaseDC(NULL, hdc);
    return 0;
}
